//+------------------------------------------------------------------+
//|                                           cMessagePipeClient.mqh |
//|                                                            micle |
//|                            https://login.mql5.com/ru/users/micle |
//+------------------------------------------------------------------+
#property copyright "micle"
#property link      "https://login.mql5.com/ru/users/micle"
#property version   "1.00"

#include "cMessagePipeCommon.mqh"

class cMessagePipeClient
{
private:
   bool        SendPipeMessage2(string ToPipe, string Message);
   
public:
               cMessagePipeClient();
              ~cMessagePipeClient();
   bool        cMessagePipeClient::SendPipeMessage(string ToPipe, string Message, int RetryForSeconds = 0);

};

cMessagePipeClient::cMessagePipeClient()
{


}

cMessagePipeClient::~cMessagePipeClient()
{



}

// Sends a message to a server pipe, with optional retrying for a given number of seconds
bool cMessagePipeClient::SendPipeMessage(string ToPipe, string Message, int RetryForSeconds = 0)
{
   // Try an initial send
   if (SendPipeMessage2(ToPipe, Message)) {
      return (true);

   } else {
      // The initial send failed. Consider doing retries
      if (RetryForSeconds <= 0) {

         // Retries not allowed
         return (false);

      } else {
         // Keep retrying for n seconds
         int RetryUntilTime = (int)TimeLocal() + RetryForSeconds;
         while (TimeLocal() < RetryUntilTime) {
            if (SendPipeMessage2(ToPipe, Message)) {
               return (true);
            } else {
               // Keep retrying - with a small pause between attempts
               Sleep(100);
            }
         }

         return (false);
      }
   }
}

// Function called by the above in order to do a single attempt to send a message
bool cMessagePipeClient::SendPipeMessage2(string ToPipe, string Message)
{
   bool bReturnvalue = false;

   string strPipeName = PIPE_BASE_NAME + ToPipe;

   // Try opening a connection to a free instance of the pipe
   int PipeHandle = FileOpen(strPipeName, FILE_WRITE | FILE_BIN);
   
   if (PipeHandle == INVALID_HANDLE) {
      bReturnvalue = false;
      //Print("  ", GetLastError());

   } else {
      //WriteFile(PipeHandle, Message, StringLen(Message), BytesWritten, 0);
      uint BytesWritten = FileWriteString(PipeHandle, Message, StringLen(Message)); //    (PipeHandle, Message, StringLen(Message), BytesWritten, 0);

      if (BytesWritten > 0) {
         bReturnvalue = true;
      } else {
         bReturnvalue = false;
      }

      FileClose(PipeHandle);
   }
      
   return(bReturnvalue);
   
}